image: docker:latest
services:
- docker:dind

stages:
- build
- test
- release

variables:
  TEST_IMAGE: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME:$CI_COMMIT_REF_NAME
  RELEASE_IMAGE: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME:latest

before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY

build:
  stage: build
  script:
    - echo "start image build..."
    - docker build -t $TEST_IMAGE .
    - docker push $TEST_IMAGE
    - echo "image successfully built!"

test:
  stage: test
  script:
    - echo "start image test..."
    - docker pull $TEST_IMAGE
    - echo "try to start the container..."
    - docker run -d -p 3306:3306 -p 5121:5121 -p 6121:6121 -p 6900:6900 --name ragnarok $TEST_IMAGE
    - echo "container launched successfully!"
    - docker stop ragnarok
    - echo "image tested successfully!"
    
release:
  stage: release
  script:
    - echo "start pulling image..."
    - docker pull $TEST_IMAGE
    - docker tag $TEST_IMAGE $RELEASE_IMAGE
    - docker push $RELEASE_IMAGE
    - echo "image pulling successfully!"
  only:
    - master
